// Copyright 2019 RnD Center "ELVEES", JSC

#ifndef UTILS_H_
#define UTILS_H_

#include <tinyxml2.h>

#include <vector>
#include <map>
#include <string>

#include "cvatparse.h"

std::map<std::string, std::string> parse_attr(tinyxml2::XMLElement *xml_attr);
void serialize_attr(tinyxml2::XMLDocument &xml_doc,
                    tinyxml2::XMLElement *ppoints,
                    const std::map<std::string, std::string> &attrs);
bool load_xml(tinyxml2::XMLDocument &xml_doc, const std::string &path);
void load_elems(tinyxml2::XMLElement *pimage, std::vector<cvatparse::image> &images);
void load_elems(tinyxml2::XMLElement *ptrack, std::vector<cvatparse::track> &tracks);
void dump_elems(tinyxml2::XMLDocument &xml_doc,
                tinyxml2::XMLNode *pannotations,
                std::vector<cvatparse::image> &images);
void dump_elems(tinyxml2::XMLDocument &xml_doc,
                tinyxml2::XMLNode *pannotations,
                const std::vector<cvatparse::track> &tracks);

#endif  // UTILS_H_
